jjb: system-tests: remove LTTng stable-2.9 tests
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
5a196804 1#!/bin/bash -exu
f3d8604b 2#
1d5a0a3c 3# Copyright (C) 2016-2019 - Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
39961776
MJ
18# Parameters
19arch=${arch:-}
20cross_arch=${cross_arch:-}
21ktag=${ktag:-}
5a196804
MJ
22kgitrepo=${kgitrepo:-}
23mversion=${mversion:-}
24mgitrepo=${mgitrepo:-}
39961776
MJ
25
26
339db64d
MJ
27## FUNCTIONS ##
28
f3d8604b
MJ
29# Kernel version compare functions
30verlte() {
51fa2ab3 31 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
32}
33
34verlt() {
28b10e79 35 # shellcheck disable=SC2015
51fa2ab3 36 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
37}
38
39vergte() {
51fa2ab3 40 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
41}
42
43vergt() {
28b10e79 44 # shellcheck disable=SC2015
51fa2ab3 45 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
46}
47
339db64d 48
5a196804
MJ
49git_clone_modules_sources() {
50 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
51
52 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
53 # as a branch name.
54 if [ "${mversion:0:5}" = "refs/" ]; then
55 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
56 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
57 else
58 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
59 fi
5a196804
MJ
60}
61
62# Checkout a shallow kernel tree of the specified tag
63git_clone_linux_sources() {
64 mkdir -p "$LINUX_GIT_DIR"
65 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
66}
7e02032c 67
7e02032c 68
5a196804
MJ
69# Export the kernel sources from the git repo
70git_export_linux_sources() {
71 cd "$LINUX_GIT_DIR"
72 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
73}
74
75
76# Upload the tar archive to the object store
77upload_archive_obj() {
78 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
79 rm -f "$WORKSPACE/$obj_name"
80}
81
82
83extract_archive_obj() {
84 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
85 rm -f "$WORKSPACE/$obj_name"
86}
87
88
89tar_archive_obj() {
90 cd "$LINUX_OBJ_DIR"
91 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
92 cd -
93}
94
95# Find the most recent GCC version supported by the kernel sources
96select_compiler() {
97 local selected_cc
98
99 cd "$LINUX_SRCOBJ_DIR"
100
101 kversion=$(make -s kernelversion)
102
103 set +e
104
1d5a0a3c 105 for cc in gcc-5 gcc-4.8; do
5a196804
MJ
106 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
107 selected_cc="$cc"
108 break
109 fi
110 done
111
112 set -e
113
114 if [ "x$selected_cc" = "x" ]; then
115 echo "Found no suitable compiler."
116 exit 1
117 fi
118
1d5a0a3c
MJ
119 # Force gcc-4.8 for kernels before 3.18
120 if { verlt "$kversion" "3.18"; }; then
23db2292 121 selected_cc=gcc-4.8
7e02032c
MJ
122 fi
123
425e4992
MJ
124 if [ "$selected_cc" != "gcc-4.8" ]; then
125 # Older kernel Makefiles do not expect the compiler to default to PIE
126 KAFLAGS="-fno-pie"
c45b04df 127 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
128 KCPPFLAGS="-fno-pie"
129 export KAFLAGS KCFLAGS KCPPFLAGS
130 fi
131
5a196804 132 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 133 export HOSTCC="${selected_cc}"
5a196804
MJ
134
135 cd -
136}
137
138
139build_linux_kernel() {
140 cd "$LINUX_SRCOBJ_DIR"
141
142 kversion=$(make -s kernelversion)
143
7e02032c 144 # Generate kernel configuration
a1ae361e 145 case "$ktag" in
7e02032c 146 Ubuntu*)
39961776 147 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 148 if vergte "${kversion}" "4.10"; then
39961776
MJ
149 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
150 exit 0
151 fi
152 fi
af101606
MJ
153
154 # Disable riscv64 config generation, we don't have a toolchain on bionic
155 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
156
a46abb0a
MJ
157 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
158 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 159 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 160 ;;
c45b04df 161
7e02032c 162 *)
16844a6d
MJ
163 # Force 32bit build on i386, default is 64bit
164 if [ "$arch" = "i386" ]; then
5a196804
MJ
165 export ARCH="i386"
166 fi
167
168 # allyesconfig is mostly broken for kernels of the 2.6 series
169 if verlt "$kversion" "3.0"; then
170 vanilla_config="defconfig"
7a76a4d0
MJ
171 fi
172
5a196804 173 make "${vanilla_config}"
7e02032c
MJ
174 ;;
175 esac
176
53b51a15 177 # oldnoconfig was renamed in 4.19
5a196804 178 if vergte "$kversion" "4.19"; then
53b51a15 179 update_conf_target="olddefconfig"
5a196804 180 else
53b51a15 181 update_conf_target="oldnoconfig"
5a196804
MJ
182 fi
183
184 # Fix 'defined(@array)' was removed from recent perl
185 if [ -f "kernel/timeconst.pl" ]; then
186 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
187 fi
188
189 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 190 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
191 if [ -f "arch/x86/kvm/svm.c" ]; then
192 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
193 fi
194
195 if [ -f "arch/x86/kvm/vmx.c" ]; then
196 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
197 fi
198 fi
199
53b51a15
MJ
200 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
201 # Convert them to 'cmpw' which was previously done silently
202 if verlt "$kversion" "4.9"; then
203 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
204 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
205 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
206 fi
207
5a196804
MJ
208 # Fix a typo in v2.6.36.x
209 if [ -f "arch/x86/kernel/entry_64.S" ]; then
210 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
211 fi
212
53b51a15
MJ
213 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
214 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
215 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
216 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
217 fi
218
5a196804
MJ
219 # Fix kernel < 3.0 with gcc >= 4.7
220 if verlt "$kversion" "3.0"; then
221 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
222 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
223 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
224 echo "header-y += linkage.h" >> include/linux/Kbuild
225 fi
226
7e02032c 227 # GCC 4.8
53b51a15
MJ
228 if [ "$HOSTCC" == "gcc-4.8" ]; then
229 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
230 fi
7e02032c
MJ
231
232 # Don't try to sign modules
53b51a15 233 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 234
9ef18fa2 235 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 236 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
237
238 # Cause problems with inline assembly on i386
53b51a15 239 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 240
1d5a0a3c 241 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
242 scripts/config --disable CONFIG_SAMPLES
243 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
244
245 # Disable kcov
53b51a15 246 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
247
248 # Broken on some RT kernels
53b51a15 249 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 250
1e300ea9 251 # Broken drivers
53b51a15
MJ
252 scripts/config --disable CONFIG_RAPIDIO_TSI721
253 scripts/config --disable CONFIG_SGI_XP
254 scripts/config --disable CONFIG_MFD_WM8994
255 scripts/config --disable CONFIG_DRM_RADEON
256 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 257
5a196804
MJ
258 # IGBVF won't build with recent gcc on 2.6.38.x
259 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 260 scripts/config --disable CONFIG_IGBVF
5a196804 261 fi
9ef18fa2 262
51fa2ab3 263 # Set required options
53b51a15
MJ
264 scripts/config --enable CONFIG_TRACEPOINTS
265 scripts/config --enable CONFIG_KALLSYMS
266 scripts/config --enable CONFIG_HIGH_RES_TIMERS
267 scripts/config --enable CONFIG_KPROBES
268 scripts/config --enable CONFIG_FTRACE
269 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
270 scripts/config --enable CONFIG_KALLSYMS_ALL
271 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
272 scripts/config --enable CONFIG_PERF_EVENTS
273 scripts/config --enable CONFIG_EVENT_TRACING
274 scripts/config --enable CONFIG_KRETPROBES
7e02032c 275
7a76a4d0 276 # Debug
5a196804
MJ
277 #cat .config
278
279 make "$update_conf_target" CC="$CC"
280 make -j"$NPROC" CC="$CC"
281
c45b04df 282 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
283
284 # Save the kernel and modules
285 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15
MJ
286 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
287 make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
288 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
289 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
290 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
291}
292
293
294extract_distro_headers() {
295
296 # Enter linux source dir
297 cd "${LINUX_SRCOBJ_DIR}"
298
299
300 # For RT kernels, copy version file
301 if [ -s localversion-rt ]; then
302 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
303 fi
304
305 # Copy all Makefile related stuff
306 find . -path './include/*' -prune \
307 -o -path './scripts/*' -prune -o -type f \
308 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
309 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
310 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
311
312 # Copy base scripts and include dirs
313 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 314
5a196804
MJ
315 # Copy arch includes
316 (find arch -name include -type d -print0 | \
317 xargs -0 -n1 -i: find : -type f) | \
318 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
319
320 # Copy arch scripts
321 (find arch -name scripts -type d -print0 | \
322 xargs -0 -n1 -i: find : -type f) | \
323 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
324
325 # Cleanup scripts
326 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
327 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
328
04873cc3 329 # On powerpc 32bits this object is required to link modules
5a196804 330 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
331 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
332 :
333 else
04873cc3
MJ
334 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
335 fi
5a196804
MJ
336 fi
337
338 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
339 if [ "${karch}" = "arm64" ]; then
340 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
341 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
342 fi
343 fi
344
345 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
346 if [ -f tools/objtool/objtool ]; then
347 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
348 fi
349
350 if [ -f "arch/x86/kernel/macros.s" ]; then
351 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
352 fi
353
354 # Copy modules related stuff, if available
355 if [ -s Module.symvers ]; then
356 cp Module.symvers "${LINUX_HDROBJ_DIR}"
357 fi
358
359 if [ -s System.map ]; then
360 cp System.map "${LINUX_HDROBJ_DIR}"
361 fi
362
363 if [ -s Module.markers ]; then
364 cp Module.markers "${LINUX_HDROBJ_DIR}"
365 fi
366
367 # Copy config file
368 cp .config "${LINUX_HDROBJ_DIR}"
369
370 # Make sure the Makefile and version.h have a matching timestamp so that
371 # external modules can be built
372 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
373 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
374 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
375 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
376 else
377 echo "Missing version.h"
378 exit 1
379 fi
380 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
381
382 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
383 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
384
385 # Finally clean the object files from the full source tree
386 make clean
387
388 # And regen the modules support files
389 make modules_prepare CC="$CC"
51fa2ab3 390
04873cc3 391 # On powerpc 32bits this object is required to link modules
d815b018 392 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
393 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
394 :
395 else
04873cc3
MJ
396 make arch/powerpc/lib/crtsavres.o CC="$CC"
397 fi
d815b018
MJ
398 fi
399
7a76a4d0 400 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 401 if [ "${karch}" = "arm64" ]; then
c236528e 402 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 403 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
404 fi
405 fi
406
7e02032c 407 # Version specific tasks
a1ae361e 408 case "$ktag" in
7e02032c
MJ
409 Ubuntu*)
410 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 411 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
412 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
413 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
414 ;;
415 esac
7e02032c
MJ
416}
417
418
339db64d
MJ
419build_modules() {
420
5a196804
MJ
421 local kdir="$1"
422 local outdir="$2"
423 local kversion
424
425 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 426
339db64d 427 # Enter lttng-modules source dir
5a196804 428 cd "${MODULES_GIT_DIR}"
339db64d
MJ
429
430 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
431 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
432 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
433 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
434
435 set +e
436
437 # Build modules
51fa2ab3 438 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 439 ret=$?
339db64d 440
5a196804
MJ
441 set -e
442
339db64d 443 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 444 if [ "$ret" -eq 0 ]; then
e9b44189 445 echo "This build should have failed."
339db64d
MJ
446 exit 1
447 fi
448
449 # We have to publish at least one file or the build will fail
5a196804 450 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 451
5a196804 452 KERNELDIR="${kdir}" make clean
7e02032c 453
339db64d
MJ
454 else # Regular build
455
456 # Build modules against full kernel sources
51fa2ab3 457 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
458
459 # Install modules to build dir
5a196804 460 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
461
462 # Clean build dir
5a196804 463 KERNELDIR="${kdir}" make clean
339db64d
MJ
464 fi
465}
466
467
468## MAIN ##
469
f3d8604b
MJ
470# Use all CPU cores
471NPROC=$(nproc)
472
5a196804
MJ
473MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
474LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 475
5a196804
MJ
476LINUX_OBJ_DIR="${WORKSPACE}/linux"
477LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
478LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
479LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 480
5a196804
MJ
481MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
482MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 483
5a196804
MJ
484LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
485
486OBJ_STORE_URL="s3://jenkins"
487
488cd "$WORKSPACE"
489
490# Create build directories
491mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
492
493git_clone_modules_sources
339db64d 494
7e02032c 495# Setup cross compile env if available
39961776 496if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
497
498 case "$cross_arch" in
499 "armhf")
500 karch="arm"
501 cross_compile="arm-linux-gnueabihf-"
53b51a15 502 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
503 ubuntu_config="armhf-config.flavour.generic"
504 ;;
505
506 "arm64")
507 karch="arm64"
508 cross_compile="aarch64-linux-gnu-"
53b51a15 509 vanilla_config="defconfig"
7e02032c
MJ
510 ubuntu_config="arm64-config.flavour.generic"
511 ;;
512
513 "powerpc")
514 karch="powerpc"
515 cross_compile="powerpc-linux-gnu-"
e9b44189 516 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
517 ubuntu_config="powerpc-config.flavour.powerpc-smp"
518 ;;
519
520 "ppc64el")
521 karch="powerpc"
522 cross_compile="powerpc64le-linux-gnu-"
e9b44189 523 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
524 ubuntu_config="ppc64el-config.flavour.generic"
525 ;;
526
527 *)
51fa2ab3 528 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
529 exit 1
530 ;;
531 esac
339db64d 532
7e02032c
MJ
533 # Export variables used by Kbuild for cross compilation
534 export ARCH="${karch}"
535 export CROSS_COMPILE="${cross_compile}"
339db64d 536
7e02032c 537# Set arch specific values if we are not cross compiling
39961776 538elif [ "x${arch}" != "x" ]; then
e9b44189 539
7e02032c 540 case "$arch" in
16844a6d 541 "i386")
7e02032c 542 karch="x86"
e9b44189 543 vanilla_config="allyesconfig"
7e02032c
MJ
544 ubuntu_config="i386-config.flavour.generic"
545 ;;
546
16844a6d 547 "amd64")
7e02032c 548 karch="x86"
e9b44189 549 vanilla_config="allyesconfig"
7e02032c
MJ
550 ubuntu_config="amd64-config.flavour.generic"
551 ;;
552
553 "armhf")
554 karch="arm"
e9b44189 555 vanilla_config="allyesconfig"
7e02032c
MJ
556 ubuntu_config="armhf-config.flavour.generic"
557 ;;
558
559 "arm64")
560 karch="arm64"
e9b44189 561 vanilla_config="allyesconfig"
7e02032c
MJ
562 ubuntu_config="arm64-config.flavour.generic"
563 ;;
564
565 "powerpc")
566 karch="powerpc"
e9b44189 567 vanilla_config="allyesconfig"
7e02032c
MJ
568 ubuntu_config="powerpc-config.flavour.powerpc-smp"
569 ;;
570
571 "ppc64el")
572 karch="powerpc"
e9b44189 573 vanilla_config="allyesconfig"
7e02032c
MJ
574 ubuntu_config="ppc64el-config.flavour.generic"
575 ;;
576
577 *)
578 echo "Unsupported arch $arch"
579 exit 1
580 ;;
581 esac
582else
04873cc3 583 echo "No arch or cross_arch specified"
7e02032c
MJ
584 exit 1
585fi
339db64d 586
339db64d 587
b214d997 588
5a196804
MJ
589# First get the kernel build from the object store, or build it, if it's
590# not available.
339db64d 591
5a196804
MJ
592echo "# Setup endpoint
593host_base = obj.internal.efficios.com
594host_bucket = obj.internal.efficios.com
595bucket_location = us-east-1
596use_https = True
7e02032c 597
5a196804
MJ
598# Setup access keys
599access_key = jenkins
600secret_key = echo123456
339db64d 601
5a196804
MJ
602# Enable S3 v4 signature APIs
603signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 604
c45b04df 605url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 606obj_name="linux.tar.bz2"
c45b04df 607obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/${cross_arch:-native}"
5a196804 608obj_url="$obj_url_prefix/$obj_name"
339db64d 609
5a196804
MJ
610set +e
611s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
612ret=$?
613set -e
339db64d 614
5a196804
MJ
615case "$ret" in
616 "0")
617 extract_archive_obj
618 ;;
a1ae361e 619
5a196804
MJ
620 "12")
621 echo "File not found"
339db64d 622
5a196804
MJ
623 # Build all the things and upload
624 # then finish the module build...
339db64d 625
5a196804
MJ
626 git_clone_linux_sources
627 git_export_linux_sources
339db64d 628
5a196804 629 select_compiler
a1ae361e 630
5a196804
MJ
631 ## PREPARE FULL LINUX SOURCE TREE
632 build_linux_kernel
d138fc44 633
5a196804
MJ
634 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
635 extract_distro_headers
339db64d 636
5a196804 637 tar_archive_obj
339db64d 638
5a196804 639 upload_archive_obj
339db64d 640
5a196804 641 ;;
339db64d 642
5a196804
MJ
643 *)
644 echo "Unknown error? Abort"
645 exit 1
646 ;;
647esac
339db64d 648
5a196804 649select_compiler
f3d8604b 650
7e02032c 651## BUILD modules
5a196804
MJ
652# Either we downloaded a pre-build kernel or we built it and uploaded
653# the archive for future builds.
654
655cd "$WORKSPACE"
f3d8604b 656
339db64d 657# Build modules against full kernel sources
5a196804 658build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 659
339db64d 660# Build modules against kernel headers
5a196804 661build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 662
5a196804
MJ
663# Make sure some modules were actually built
664tree "${MODULES_OUTPUT_KSRC_DIR}"
665if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
666 echo "No modules built!"
667 exit 1
668fi
669
5a196804
MJ
670tree "${MODULES_OUTPUT_KHDR_DIR}"
671if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
672 echo "No modules built!"
673 exit 1
674fi
b214d997 675
f3d8604b 676# EOF
This page took 0.058074 seconds and 4 git commands to generate.